{ 2003-12-13 programmeerimisvistluse edasijudnute 1. lesande lahendus    }
{ lesanne: RISTKLIKUD                                                     }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32, TPC 6.0                                      }

const
   sisf = 'RIST.SIS';                                    { sisendfaili nimi }
   valf = 'RIST.VAL';                                   { vljundfaili nimi }
   maxn = 100;                                   { maksimaalne punktide arv }

type
   punkt = record                                           { punkti andmed }
      x, y : longint;                                        { koordinaadid }
   end;

var
   n : integer;                                              { punktide arv }
   p : array [1..maxn] of punkt;                                  { punktid }

{ kontrollib, kas p[i1], p[i2], p[i3] vivad olla ristkliku kolm tippu     }
{ kui jah, i4 := neljanda tipu number, s := ristkliku pindala              }
function ristkyl(i1, i2, i3 : integer; var i4 : integer; var s : longint) : boolean;
var k1, k2, k3, k : longint; i, x, y : integer;
begin
   { leiame kljepikkuste ruudud }
   k1 := sqr(p[i2].x - p[i3].x) + sqr(p[i2].y - p[i3].y);
   k2 := sqr(p[i3].x - p[i1].x) + sqr(p[i3].y - p[i1].y);
   k3 := sqr(p[i1].x - p[i2].x) + sqr(p[i1].y - p[i2].y);
   { jrjestame nii, et k1 oleks maksimaalne }
   if k1 < k2 then begin
      k := k1; k1 := k2; k2 := k;
      i := i1; i1 := i2; i2 := i;
   end;
   if k1 < k3 then begin
      k := k1; k1 := k3; k3 := k;
      i := i1; i1 := i3; i3 := i;
   end;
   { maksimaalne peab olema kahe lejnu summa }
   if not (k1 = k2 + k3) then begin
      { muidu pole tisnurkne, jrelikult pole ristklik }
      ristkyl := false;
      exit;
   end;
   { otsime neljandat tippu }
   x := p[i3].x + p[i2].x - p[i1].x; y := p[i3].y + p[i2].y - p[i1].y;
   for i := 1 to n do
      if (p[i].x = x) and (p[i].y = y) then begin
         { kui leidsime, on ristklik }
         i4 := i; s := round(sqrt(k2) * sqrt(k3));
         ristkyl := true;
         exit;
      end;
   ristkyl := false;
end;

var
   f : text;
   i : integer;
   i1, i2, i3, i4 : integer;                     { jooksva ristkliku tipud }
   s : longint;                                { jooksva ristkliku pindala }
   ii1, ii2, ii3, ii4 : integer;                  { leitud ristkliku tipud }
   ss : longint;                                { leitud ristkliku pindala }
begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, p[i].x, p[i].y);
   close(f);

   { lahendame lesande }
   ss := -1;
   { vaatleme kiki punktikolmikuid }
   for i1 := 1 to n do
      for i2 := i1 + 1 to n do
         for i3 := i2 + 1 to n do
            if ristkyl(i1, i2, i3, i4, s) then
               if (ss < 0) or (s < ss) then begin
                  ii1 := i1; ii2 := i2; ii3 := i3; ii4 := i4; ss := s;
               end;

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, ii1, ' ', ii2, ' ', ii3, ' ', ii4);
   close(f);
end.
