{ 2003-12-13 programmeerimisvistluse edasijudnute 3. lesande lahendus    }
{ lesanne: SILBITAMINE                                                     }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32, TPC 6.0                                      }

const
   sisf = 'SILBE.SIS';                                   { sisendfaili nimi }
   valf = 'SILBE.VAL';                                  { vljundfaili nimi }

type
   olek = (                                                { algoritmi olek }
      olek_0,                                                 { silbi algus }
      olek_K,                                         { ainult kaashlikud }
      olek_T,                                              { ks tishlik }
      olek_TT,                                          { kaks tishlikut }
      olek_TK                                 { tishlikud + kaashlikud }
   );

{ kontrollib, kas c on tishlik }
function tais(c : char) : boolean;
begin
   tais := upcase(c) in ['A', 'E', 'I', 'O', 'U', 'Y'];
end;

{ kontrollib, kas c on kaashlik }
function kaas(c : char) : boolean;
begin
   kaas := (upcase(c) in ['A'..'Z']) and not tais(c);
end;

{ olekumasin: kontrollib, kas c1 alustab uut silpi }
function silp(var o : olek; c1, c2 : char) : boolean;
begin
   silp := false;                                   { eeldame, et ei alusta }
   if tais(c1) then begin                           { jooksev on tishlik }
      if (o = olek_0) or (o = olek_K) then begin
         o := olek_T
      end else if (o = olek_T) then begin
         o := olek_TT;
      end else if (o = olek_TT) then begin
         silp := true;                                          { 4. reegel }
         o := olek_T;
      end else if (o = olek_TK) then begin
         writeln('VIGA')                        { sellist asja ei saa olla! }
      end;
   end else if kaas(c1) then begin                  { jooksev on kaashlik }
      if (o = olek_0) or (o = olek_K) then begin
         o := olek_K;
      end else if (o = olek_T) or (o = olek_TT) or (o = olek_TK) then begin
         if tais(c2) then begin
            silp := true;                                 { 1. ja 2. reegel }
            o := olek_K;
         end else
            o := olek_TK;
      end;
   end else begin                                   { jooksev on muu smbol }
      o := olek_0;
   end;
end;

var
   f1, f2 : text;                    { failimuutujad sisendi-vljundi jaoks }
   c1, c2 : char;                                       { jooksvad smbolid }
   o : olek;                                               { algoritmi olek }
begin
   assign(f1, sisf); reset(f1);
   assign(f2, valf); rewrite(f2);
   readln(f1);             { jtame ridade arvu vahele, seda pole meil vaja }
   if not eof(f1) then begin
      read(f1, c1);                           { loeme he smboli jooksvaks }
      o := olek_0;                             { praegu oleme silbi alguses }
      while not eof(f1) do begin
         read(f1, c2);                             { loeme jrgmise smboli }
         { nd on piisavalt infot, et otsustada, mida teha jooksvaga }
         if silp(o, c1, c2) then
            write(f2, '-');
         write(f2, c1);                              { jooksev smbol vlja }
         c1 := c2;                          { jrgmine saab uueks jooksvaks }
      end;
      if silp(o, c1, ' ') then      { viimase ttleme, nagu jrgneks thik }
         write(f2, '-');
      write(f2, c1);                                     { viimane ka vlja }
   end;
   close(f1);
   close(f2);
end.
