{ 2003-12-13 programmeerimisvistluse algajate 3. lesande lahendus         }
{ lesanne: SILBITAMINE                                                     }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32, TPC 6.0                                      }

const
   sisf = 'SILBA.SIS';                                   { sisendfaili nimi }
   valf = 'SILBA.VAL';                                  { vljundfaili nimi }

type
   olek = (                                                { algoritmi olek }
      olek_0,                                                 { silbi algus }
      olek_K,                                         { ainult kaashlikud }
      olek_T,                                              { ks tishlik }
      olek_TT,                                          { kaks tishlikut }
      olek_TK                                 { tishlikud + kaashlikud }
   );

var
   s : string;                                               { jooksev sna }

{ kontrollib, kas s[i] on tishlik }
function tais(i : integer) : boolean;
begin
   if (i < 0) or (i > length(s)) then
      tais := false
   else
      tais := s[i] in ['a', 'e', 'i', 'o', 'u', 'y'];
end;

var
   n : integer;                                                { snade arv }
   f1, f2 : text;                    { failimuutujad sisendi-vljundi jaoks }
   i, j : integer;                             { abimuutujad korduste jaoks }
   o : olek;                                               { algoritmi olek }
begin
   assign(f1, sisf); reset(f1);
   assign(f2, valf); rewrite(f2);
   readln(f1, n);
   for i := 1 to n do begin
      readln(f1, s);
      o := olek_0;                             { praegu oleme silbi alguses }
      for j := 1 to length(s) do begin
         { otsustame, mida teha jooksva smboliga }
         if tais(j) then begin                      { jooksev on tishlik }
            if (o = olek_0) or (o = olek_K) then begin
               o := olek_T
            end else if (o = olek_T) then begin
               o := olek_TT;
            end else if (o = olek_TT) then begin
               write(f2, '-');                                  { 4. reegel }
               o := olek_T;
            end else if (o = olek_TK) then begin
               writeln('VIGA')                  { sellist asja ei saa olla! }
            end;
         end else begin                             { jooksev on kaashlik }
            if (o = olek_0) or (o = olek_K) then begin
               o := olek_K;
            end else if (o = olek_T) or (o = olek_TT) or (o = olek_TK) then begin
               if tais(j + 1) then begin
                  write(f2, '-');                         { 1. ja 2. reegel }
                  o := olek_K;
               end else
                  o := olek_TK;
            end;
         end;
         write(f2, s[j]);                            { jooksev smbol vlja }
      end;
      writeln(f2);
   end;
   close(f1);
   close(f2);
end.
