{ 2003-12-13 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{ lesanne: SORTIMINE                                                       }
{ Autor: Avo Muromgi                                                       }
{ Testitud: FPC 1.0.6 / Win32                                               }

{ Kasutab kiirmeetodit.                                                     }

const
 maxn = 30000;
 fn = 'SORT';

var
 a : array [1..maxn] of longint;
 n : longint;

{Valib massiivist a[lo, hi] juhusliku elemendi ning tstab kik sellest
elemendist viksemad elemendid endast vasakule ja suuremad elemendid
paremale. Kui see on tehtud korratakse seda eraldi leitud juhuslikust
elemendist vasakule tstetud arvudega ja paremale tstetud arvudega.}
procedure qsort(lo, hi : longint);
  var
   iLo, iHi, m : longint;
   t : longint;
   x : longint;
  begin
    iLo := lo;
    iHi := hi;

    x := random(hi - lo + 1) + lo;
    t := a[x];
    a[x] := a[(lo + hi) div 2];
    a[(lo + hi) div 2] := t;

    m := a[(lo + hi) div 2];
    repeat
      while a[iLo] < m do inc(iLo);
      while a[iHi] > m do dec(iHi);
      if (iLo <= iHi) then begin
        t := a[iLo];
        a[iLo] := a[iHi];
        a[iHi] := t;
        inc(iLo);
        dec(iHi);
      end;
    until (iLo > iHi);
    if iLo < hi then qsort(iLo, hi);
    if lo < iHi then qsort(lo, iHi);
  end;

var
 inf, outf : text;
 i : longint;

begin
  assign(inf, fn + '.SIS');reset(inf);
  assign(outf, fn + '.VAL');rewrite(outf);

  readln(inf, n);
  for i := 1 to n do
    read(inf, a[i]);
  qsort(1, n);

  for i := 1 to n do begin
    if odd(i) then write(outf, a[n - i div 2])
    else write(outf, a[i div 2]);
    if i < n then write(outf, ' ') else writeln(outf);
  end;

  close(inf);close(outf);
end.
