{ 2003-12-13 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{ lesanne: SORTIMINE                                                       }
{ Autor: Avo Muromgi                                                       }
{ Testitud: FPC 1.0.6 / Win32                                               }

{ Kasutab hildusmeetodit.                                                  }

const
 maxn = 30000;
 fn = 'SORT';

var
 a : array [1..maxn] of longint;
 n : longint;
 b : array [1..maxn] of longint;

{Kopeerib kaks jrjestatud alamjada kokku, mis toimub jrgmiselt. 
Kigepealt vetakse element alamjadast, mille esimene element on vikseim
ning mrgitakse selle alamjada esimeseks elemendiks jrgmine selle alamjada
element, nd vetakse element jllegi sellest alamjadast, mille esimene
element on viksem jne.}
procedure merge(x, z : longint);
  var
   i, j : longint;
   y, k : longint;
  begin
    y := (x + z) div 2;
    i := x;j := y + 1;
    k := x - 1;
    {kopeerime jada a[x..z] kokku mittekahanevaks}
    while (i <= y) or (j <= z) do begin
    	inc(k);
      if (i <= y) and (j <= z) then
        if a[i] <= a[j] then begin
          b[k] := a[i];
          inc(i);
        end
        else begin
          b[k] := a[j];
          inc(j);
        end
      else if j > z then begin
        b[k] := a[i];
        inc(i);
      end
      else begin
        b[k] := a[j];
        inc(j);
      end;
    end;

    for i := x to z do
    	a[i] := b[i];
  end;

{hildusmeetodi rekursiivne protseduur jagab etteantavat jada kaheks, kuni
alamjadas on 1 element. Seejrel hakatakse uuesti les tulema, kopeerides
alamjadad kokku protseduuri merge abil.}
procedure msort(x, y : longint);
  begin
    if x < y then begin
      msort(x, (x + y) div 2);
      msort((x + y) div 2 + 1, y);
      merge(x, y);
    end;
  end;

var
 inf, outf : text;
 i : longint;

begin
  assign(inf, fn + '.SIS');reset(inf);
  assign(outf, fn + '.VAL');rewrite(outf);

  readln(inf, n);
  for i := 1 to n do
    read(inf, a[i]);
  msort(1, n);

  for i := 1 to n do begin
    if odd(i) then write(outf, a[n - i div 2])
    else write(outf, a[i div 2]);
    if i < n then write(outf, ' ') else writeln(outf);
  end;

  close(inf);close(outf);
end.
